package cc.niushuai.dididone.biz.dao;

import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.Query;
import androidx.room.Update;

import java.util.List;

import cc.niushuai.dididone.biz.entity.Project;
import io.reactivex.Completable;
import io.reactivex.Flowable;

@Dao
public interface ProjectDao {

    @Query("SELECT * FROM t_project")
    Flowable<List<Project>> listAllWithDeleted();

    @Query("SELECT * FROM t_project where deleted = 0 order by create_date desc")
    Flowable<List<Project>> listAll();

    @Query("SELECT count(*) FROM t_project where deleted = 0 and name = :name")
    Flowable<Integer> countByName(String name);

    @Insert
    Completable insertAll(List<Project> projects);

    @Insert
    Completable insertAll(Project... projects);

    @Query("update t_project set deleted = 1 where id = :id")
    void deleteById(Long id);

    @Delete
    void physicsDelete(Project project);

    @Query("delete from t_project where id = :id")
    void physicsDeleteById(Long id);

    @Query("update t_project set name = :name, icon = :icon, icon_color = :color where id = :id")
    void update(Long id, String name, String icon, Integer color);
    @Update
    int update(Project project);
}
