package cc.niushuai.dididone.biz.roomx;

import android.content.Context;

import androidx.room.Room;
import androidx.room.RoomDatabase;

import cc.niushuai.dididone.biz.dao.ProjectDao;
import cc.niushuai.dididone.biz.dao.RecordDao;
import cc.niushuai.dididone.biz.dao.SavedIconDao;

public class DBManager {

    public static DBManager INSTANCE;
    private Context context;
    private Database database;

    public DBManager(Context context) {
        this.context = context;
    }

    public static void init(Context context) {
        if (null != INSTANCE) {
            return;
        }
        INSTANCE = new DBManager(context);
    }

    public static RoomDatabase buildDatabase(Context context, Class<? extends RoomDatabase> clazz, String dbName) {
        RoomDatabase.Builder<? extends RoomDatabase> databaseBuilder = Room.databaseBuilder(context, clazz, dbName);
        databaseBuilder.setJournalMode(RoomDatabase.JournalMode.AUTOMATIC);
        databaseBuilder.allowMainThreadQueries();
        return databaseBuilder.build();
    }

    public Database getDataBase() {
        if (null == database) {
            database = (Database) buildDatabase(context, Database.class, "darling_done.db");
        }
        return database;
    }

    public RecordDao recordDao() {
        return getDataBase().recordDao();
    }

    public ProjectDao projectDao() {
        return getDataBase().projectDao();
    }

    public SavedIconDao iconDao() {
        return getDataBase().savedIconDao();
    }
}
