package cc.niushuai.dididone.biz.vo;

import java.util.ArrayList;
import java.util.List;

import cc.niushuai.dididone.biz.entity.Project;
import cc.niushuai.dididone.util.Snowflake;

public class ProjectIcon {

    private Long id = Snowflake.next_id();
    private String projectName;
    private String icon;
    private Integer color;

    public ProjectIcon(Long id, String projectName, String icon, Integer color) {
        this.id = id;
        this.projectName = projectName;
        this.icon = icon;
        this.color = color;
    }

    public static List<ProjectIcon> trans(List<Project> projectList) {

        ArrayList<ProjectIcon> list = new ArrayList<>(projectList.size());
        for (Project project : projectList) {
            list.add(new ProjectIcon(project.getId(), project.getName(), project.getIcon(), project.getIconColor()));
        }
        return list;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public Integer getColor() {
        return color;
    }

    public void setColor(Integer color) {
        this.color = color;
    }
}
