package cc.niushuai.dididone.ui.base;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import cc.niushuai.dididone.util.XLog;

public abstract class BaseFragment extends Fragment implements InitAndSetListener {

    @Override
    public void onStart() {
        XLog.d("{} onStart", getClass().getSimpleName());
        super.onStart();
    }

    @Override
    public void onDestroy() {
        XLog.d("{} onDestroy", getClass().getSimpleName());
        super.onDestroy();
    }

    @Override
    public void onDestroyView() {
        XLog.d("{} onDestroyView", getClass().getSimpleName());
        super.onDestroyView();
    }

    @Override
    public void onViewStateRestored(@Nullable Bundle savedInstanceState) {
        XLog.d("{} onViewStateRestored", getClass().getSimpleName());
        super.onViewStateRestored(savedInstanceState);
    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        XLog.d("{} onCreate", getClass().getSimpleName());
        super.onCreate(savedInstanceState);
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        XLog.d("{} onCreateView", getClass().getSimpleName());
        return super.onCreateView(inflater, container, savedInstanceState);
    }


    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        XLog.d("{} {} onViewCreated", getId(), getClass().getName());
        super.onViewCreated(view, savedInstanceState);

        init();

        setListeners();

    }

}
