package cc.niushuai.dididone.ui.setting.icon;

import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.mikepenz.community_material_typeface_library.CommunityMaterial;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Set;
import java.util.function.Predicate;

import cc.niushuai.dididone.biz.entity.SavedIcon;
import cc.niushuai.dididone.databinding.FragmentIconBinding;
import cc.niushuai.dididone.ui.base.BaseFragment;
import cc.niushuai.dididone.ui.base.InitAndSetListener;
import cc.niushuai.dididone.ui.setting.icon.recycle.IconRecycleAdapter;

public class IconFragment extends BaseFragment {

    private FragmentIconBinding binding;

    private IconRecycleAdapter iconRecycleAdapter;

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {

        binding = FragmentIconBinding.inflate(inflater, container, false);
        View root = binding.getRoot();

        return root;
    }


    /**
     * 初始化数据
     */
    @Override
    public void init() {

//        initSpinner();
        initRecyclerView();
    }

//    private void initSpinner() {
//        Set<String> keySet = IconRecycleAdapter.ICON_MAP.keySet();
//        ArrayList<String> keys = new ArrayList<>(keySet);
//        Collections.sort(keys);
//        binding.iconsSelect.setAdapter(new ArrayAdapter<String>(getContext(), com.necer.R.layout.support_simple_spinner_dropdown_item, keys));
//        binding.iconsSelect.setSelection(0);
//
//        binding.iconsSelect.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
//            /**
//             * @param parent   The AdapterView where the selection happened
//             * @param view     The view within the AdapterView that was clicked
//             * @param position The position of the view in the adapter
//             * @param id       The row id of the item that is selected
//             */
//            @Override
//            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
//                String key = keys.get(position);
//                String str = binding.iconsSearch.getText().toString();
//                Predicate<SavedIcon> filter = item -> true;
//                if (null != str && str.length() > 0) {
//                    filter = item -> item.getIcon().contains(str);
//                }
//                iconRecycleAdapter.change(key, filter);
//            }
//
//            /**
//             * @param parent The AdapterView that now contains no selected item.
//             */
//            @Override
//            public void onNothingSelected(AdapterView<?> parent) {
//
//            }
//        });
//    }

    private void initRecyclerView() {
        binding.iconsRecyclerView.addItemDecoration(new DividerItemDecoration(this.getActivity(), DividerItemDecoration.VERTICAL));
        DefaultItemAnimator itemAnimator = new DefaultItemAnimator();
        itemAnimator.setAddDuration(1000);
        itemAnimator.setRemoveDuration(1000);
        binding.iconsRecyclerView.setItemAnimator(itemAnimator);

        LinearLayoutManager layoutManager = new LinearLayoutManager(getActivity());
        binding.iconsRecyclerView.setLayoutManager(layoutManager);

        iconRecycleAdapter = new IconRecycleAdapter(getActivity());
        binding.iconsRecyclerView.setAdapter(iconRecycleAdapter);
    }

    /**
     * 控件添加监听器
     */
    @Override
    public void setListeners() {

        setSelectListener();
    }

    private void setSelectListener() {
        addIconSearchListener();
    }

    private void addIconSearchListener() {
        binding.iconsSearch.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            }

            @Override
            public void afterTextChanged(Editable s) {
                iconRecycleAdapter.change(item -> item.getIcon().contains(s.toString()));
            }
        });
    }
}
