package cc.niushuai.dididone.ui.setting.project;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.mikepenz.iconics.IconicsDrawable;

import java.util.List;

import cc.niushuai.dididone.R;
import cc.niushuai.dididone.biz.vo.ProjectIcon;

public class GridViewAdapter4Project extends BaseAdapter {

    protected List<ProjectIcon> projectIconList;
    private Context context;

    public GridViewAdapter4Project(Context context, List<ProjectIcon> projectIconList) {
        this.context = context;
        this.projectIconList = projectIconList;
    }

    @Override
    public int getCount() {
        return projectIconList.size();
    }

    @Override
    public ProjectIcon getItem(int position) {
        return projectIconList.get(position);
    }

    @Override
    public long getItemId(int position) {
        return getItem(position).getId();
    }

    @Override
    public View getView(int position, View view, ViewGroup parent) {

        ProjectIcon iconData = projectIconList.get(position);

        if (view == null) {
            view = LayoutInflater.from(context).inflate(R.layout.project_grid_item, parent, false);
        }
        ImageView icon = view.findViewById(R.id.grid_project_item_icon);
        icon.setImageDrawable(new IconicsDrawable(context).icon(iconData.getIcon()).color(iconData.getColor()).sizeDp(50));

        TextView txt = view.findViewById(R.id.grid_project_item_txt);
        txt.setText(iconData.getProjectName());

        return view;
    }
}
